
#include <windows.h>  
#include "ChkClrIG.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )
   {
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                       {
                          LOGCOLORSPACE ColorSpace;
                          HCOLORSPACE   hColorSpace;
                          RGBQUAD       aRGB[5];
                          BYTE          aResults[5];
                          HBRUSH        hBrush;
                          int           i;
                          HDC           hDC;
                          char          szMsg[30];
                          BOOL          bRet;
                           
                          // Get a DC for the printer.
                          //..........................
                          hDC = CreateDC( "WINSPOOL", 
                                          "HP DeskJet 550C Printer", 
                                          NULL, NULL );

                          // Turn on Image Color Matching.
                          //..............................
                          SetICMMode( hDC, ICM_ON );

                          // Load color array to test.
                          //..........................
                          for( i = 0; i < 5; i++ )
                          {
                             aRGB[i].rgbRed   = (i > 0 ? (255 / i) : 0 );
                             aRGB[i].rgbGreen = (i > 0 ? (255 / i) : 0 );
                             aRGB[i].rgbBlue  = (i > 0 ? (255 / i) : 0 );
                             aRGB[i].rgbReserved = 0;
                              aResults[i] = 0;
                          }

                          // Fill a structure to create a color space.
                          //..........................................
                          memset( &ColorSpace, 0, sizeof( ColorSpace ) );
                          ColorSpace.lcsSignature=(DWORD)0x50534F43;
                          ColorSpace.lcsVersion=0x00000400;
                          ColorSpace.lcsSize=sizeof( ColorSpace );
                          ColorSpace.lcsCSType=LCS_DEVICE_RGB;
                          ColorSpace.lcsIntent=LCS_GM_BUSINESS;

                          // Create a color space.
                          //......................
                          hColorSpace = CreateColorSpace( &ColorSpace );
                          SetColorSpace( hDC, hColorSpace );
                          GetLastError();

                          // Check the colors in the gamut.
                          //...............................
                          bRet = CheckColorsInGamut( hDC, aRGB, aResults, 5 ); 

                          DeleteColorSpace( hColorSpace );
                          SetICMMode( hDC, ICM_OFF );
                          DeleteDC( hDC );

                          // Display the results.
                          //.....................
                          if ( bRet )
                          {
                             hDC = GetDC( hWnd );

                             for( i = 0; i < 5; i++ )
                             {
                                hBrush = CreateSolidBrush( 
                                                   RGB( aRGB[i].rgbRed,
                                                        aRGB[i].rgbGreen,
                                                        aRGB[i].rgbBlue ) );
                                SelectObject( hDC, hBrush );

                                Rectangle( hDC, 10, (i*30)+10, 
                                                40, (i*30)+40 );

                                wsprintf( szMsg, "RGB( %d, %d, %d )",
                                                 aRGB[i].rgbRed,
                                                 aRGB[i].rgbGreen,
                                                 aRGB[i].rgbBlue );

                                TextOut( hDC, 50, (i*30)+20, szMsg, 
                                                  strlen( szMsg ) );

                                if ( aResults[i] == CM_OUT_OF_GAMUT )
                                   TextOut( hDC, 200, (i*30)+20, 
                                                 "- Not in the Gamut.", 19 );
                                else
                                   TextOut( hDC, 200, (i*30)+20, 
                                                 "- In the Gamut.", 15 );

                                SelectObject( hDC, 
                                              GetStockObject( WHITE_BRUSH ) );
                                DeleteObject( hBrush );
                             } 

                             ReleaseDC( hWnd, hDC );
                          }
                       }
                       break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
